<?php
class ControllerExtensionPaymentPossia extends Controller
{
    // Error form validate
    private $error = array();

    public function index()
    {
        $this->load->language('extension/payment/possia');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('setting/setting');
        $this->load->model('extension/payment/possia');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            // Save all settings passed via request
            $this->model_setting_setting->editSetting('payment_possia', $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
        }

        //Save all errors for template variables
        foreach($this->error as $k => $v) {
            $data['error_'.$k] = $v;
        }

        $data['breadcrumbs'] = array();
        $data['breadcrumbs'][] = array('text' => $this->language->get('text_home'), 'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true));
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true),
        );
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/payment/possia', 'user_token=' . $this->session->data['user_token'], true),
        );

        //Cta
        $data['action'] = $this->url->link('extension/payment/possia', 'user_token=' . $this->session->data['user_token'], true);
        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

        /**
         * Retrieve settings for form
         */

        /** General tab */
        if (isset($this->request->post['payment_possia_mode'])) {
            $data['payment_possia_mode'] = $this->request->post['payment_possia_mode'];
        } else {
            $data['payment_possia_mode'] = $this->config->get('payment_possia_mode');
        }

        if (isset($this->request->post['payment_possia_transaction'])) {
            $data['payment_possia_transaction'] = $this->request->post['payment_possia_transaction'];
        } else {
            $data['payment_possia_transaction'] = $this->config->get('payment_possia_transaction');
        }

        if (isset($this->request->post['payment_possia_language'])) {
            $data['payment_possia_language'] = $this->request->post['payment_possia_language'];
        } else {
            $data['payment_possia_language'] = $this->config->get('payment_possia_language');
        }

        /**
         * Order status
         */
        $this->load->model('localisation/order_status');
        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
        if (isset($this->request->post['payment_possia_paid_order_status_id'])) {
            $data['payment_possia_paid_order_status_id'] = $this->request->post['payment_possia_paid_order_status_id'];
        } else {
            $data['payment_possia_paid_order_status_id'] = $this->config->get('payment_possia_paid_order_status_id');
        }

        if (isset($this->request->post['payment_possia_notpaid_order_status_id'])) {
            $data['payment_possia_notpaid_order_status_id'] = $this->request->post['payment_possia_notpaid_order_status_id'];
        } else {
            $data['payment_possia_notpaid_order_status_id'] = $this->config->get('payment_possia_notpaid_order_status_id');
        }

        if (isset($this->request->post['payment_possia_status'])) {
            $data['payment_possia_status'] = $this->request->post['payment_possia_status'];
        } else {
            $data['payment_possia_status'] = $this->config->get('payment_possia_status');
        }

         if (isset($this->request->post['payment_possia_sort_order'])) {
             $data['payment_possia_sort_order'] = $this->request->post['payment_possia_sort_order'];
         } else {
             $data['payment_possia_sort_order'] = $this->config->get('payment_possia_sort_order');
         }

         if (isset($this->request->post['payment_possia_enable_log'])) {
             $data['payment_possia_enable_log'] = $this->request->post['payment_possia_enable_log'];
         } else {
             $data['payment_possia_enable_log'] = $this->config->get('payment_possia_enable_log');
         }


        /** Test tab set default value, readonly fields */
        $data['payment_possia_test_gateway_url'] = $this->model_extension_payment_possia->getTest_GatewayUrl();
        $data['payment_possia_test_shop_id'] = $this->model_extension_payment_possia->getTest_ShopId();
        $data['payment_possia_test_starter_key'] = $this->model_extension_payment_possia->getTest_StarterKey();
        $data['payment_possia_test_outcome_key'] = $this->model_extension_payment_possia->getTest_OutcomeKey();

        /** Production tab  set default value for, readonly fields */
        $data['payment_possia_production_gateway_url'] = $this->model_extension_payment_possia->getProduction_GatewayUrl();

        if (isset($this->request->post['payment_possia_production_shop_id'])) {
            $data['payment_possia_production_shop_id'] = $this->request->post['payment_possia_production_shop_id'];
        } else {
            $data['payment_possia_production_shop_id'] = $this->config->get('payment_possia_production_shop_id');
        }

        if (isset($this->request->post['payment_possia_production_starter_key'])) {
            $data['payment_possia_production_starter_key'] = $this->request->post['payment_possia_production_starter_key'];
        } else {
            $data['payment_possia_production_starter_key'] = $this->config->get('payment_possia_production_starter_key');
        }

        if (isset($this->request->post['payment_possia_production_outcome_key'])) {
            $data['payment_possia_production_outcome_key'] = $this->request->post['payment_possia_production_outcome_key'];
        } else {
            $data['payment_possia_production_outcome_key'] = $this->config->get('payment_possia_production_outcome_key');
        }


        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        if ($this->model_extension_payment_possia->isProductionMode($data['payment_possia_mode'])) {
            $data['possia_VPOS_Portal_Link'] = $this->model_extension_payment_possia->getVPORTAL_Link_Production();
            $data['possia_VPOS_Portal_Link_disabled'] = FALSE;
        } else {
            $data['possia_VPOS_Portal_Link'] = "";//$this->model_extension_payment_possia->getVPORTAL_Link_Test();
            $data['possia_VPOS_Portal_Link_disabled'] = TRUE;

        }

        $data['possia_transactions_list_Link'] = $this->url->link($this->model_extension_payment_possia->get_transactions_list_Link(), 'user_token=' . $this->session->data['user_token'], true);
        $data['possia_plugin_version'] = $this->model_extension_payment_possia->getVersion();
        $this->response->setOutput($this->load->view('extension/payment/possia', $data));
    }

    /**
     * Validate form fields
     *
     * @return bool
     */
    private function validate()
    {
        if (!$this->user->hasPermission('modify', 'extension/payment/possia')) {
            $this->error['warning'] = $this->language->get('error_permission');
        } else {
            if (intval($this->request->post['payment_possia_sort_order'] <= 0)) {
                $this->error['warning'] = $this->language->get('error_form_fields');
                $this->error['payment_possia_sort_order'] = $this->language->get('error_entry_possia_sort_order');
            }

            if ($this->request->post['payment_possia_mode'] == "P") {
                /* check field production mode */
                if (!$this->request->post['payment_possia_production_gateway_url']) {
                    $this->error['warning'] = $this->language->get('error_form_fields');
                    $this->error['payment_possia_production_gateway_url'] = $this->language->get('error_required_field');
                }

                if (!$this->request->post['payment_possia_production_shop_id']) {
                    $this->error['warning'] = $this->language->get('error_form_fields');
                    $this->error['payment_possia_production_shop_id'] = $this->language->get('error_required_field');
                }

                if (!$this->request->post['payment_possia_production_starter_key']) {
                    $this->error['warning'] = $this->language->get('error_form_fields');
                    $this->error['payment_possia_production_starter_key'] = $this->language->get('error_required_field');
                }
                if (!$this->request->post['payment_possia_production_outcome_key']) {
                    $this->error['warning'] = $this->language->get('error_form_fields');
                    $this->error['payment_possia_production_outcome_key'] = $this->language->get('error_required_field');
                }
            }
        }

        return !$this->error;
    }

    /**
     * Generate Query String for filter seleted
     */
    private function generateQueryString_Filter(){
        $url = '';

        if (isset($this->request->get['filter_order_id'])) {
            $url .= '&filter_order_id=' . $this->request->get['filter_order_id'];
        }

        if (isset($this->request->get['filter_customer'])) {
            $url .= '&filter_customer=' . urlencode(html_entity_decode($this->request->get['filter_customer'], ENT_QUOTES, 'UTF-8'));
        }

        if (isset($this->request->get['filter_order_status'])) {
            $url .= '&filter_order_status=' . $this->request->get['filter_order_status'];
        }

        if (isset($this->request->get['filter_order_status_id'])) {
            $url .= '&filter_order_status_id=' . $this->request->get['filter_order_status_id'];
        }

        if (isset($this->request->get['filter_total'])) {
            $url .= '&filter_total=' . $this->request->get['filter_total'];
        }

        if (isset($this->request->get['filter_date_added'])) {
            $url .= '&filter_date_added=' . $this->request->get['filter_date_added'];
        }

        if (isset($this->request->get['filter_date_modified'])) {
            $url .= '&filter_date_modified=' . $this->request->get['filter_date_modified'];
        }

        if (isset($this->request->get['filter_transaction_comment'])) {
            $url .= '&filter_transaction_comment=' . $this->request->get['filter_transaction_comment'];
        }

        return $url;
    }
    /**
     * Lista transazioni
     */
    public function transactionsList() {
        $LimitPage   = $this->config->get('config_limit_admin');
        //$LimitPage=2;
        $this->load->language('sale/order');
        $this->load->language('extension/payment/possia');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('setting/setting');
        $this->load->model('extension/payment/possia');
        $this->load->model('sale/order');


        if (isset($this->request->get['filter_order_id'])) {
            $filter_order_id = $this->request->get['filter_order_id'];
        } else {
            $filter_order_id = '';
        }

        if (isset($this->request->get['filter_customer'])) {
            $filter_customer = $this->request->get['filter_customer'];
        } else {
            $filter_customer = '';
        }

        if (isset($this->request->get['filter_order_status'])) {
            $filter_order_status = $this->request->get['filter_order_status'];
        } else {
            $filter_order_status = '';
        }

        if (isset($this->request->get['filter_order_status_id'])) {
            $filter_order_status_id = $this->request->get['filter_order_status_id'];
        } else {
            $filter_order_status_id = '';
        }


        if (isset($this->request->get['filter_total'])) {
            $filter_total = $this->request->get['filter_total'];
        } else {
            $filter_total = '';
        }

        if (isset($this->request->get['filter_date_added'])) {
            $filter_date_added = $this->request->get['filter_date_added'];
        } else {
            $filter_date_added = '';
        }

        if (isset($this->request->get['filter_date_modified'])) {
            $filter_date_modified = $this->request->get['filter_date_modified'];
        } else {
            $filter_date_modified = '';
        }
        if (isset($this->request->get['filter_transaction_comment'])) {
            $filter_transaction_comment = $this->request->get['filter_transaction_comment'];
        } else {
            $filter_transaction_comment = '';
        }

        if (isset($this->request->get['sort'])) {
            $sort = $this->request->get['sort'];
        } else {
            $sort = 'o.ORDER DATA';
        }

        if (isset($this->request->get['order'])) {
            $order = $this->request->get['order'];
        } else {
            $order = 'DESC';
        }
        if (isset($this->request->get['page'])) {
            $page = (int)$this->request->get['page'];
        } else {
            $page = 1;
        }

        /**
         * URL PER BREADCRUMB
         */
        $url = $this->generateQueryString_Filter();

        // Create breadcrumbs
        $data['breadcrumbs'] = array();
        $data['breadcrumbs'][] = array('text' => $this->language->get('text_home'), 'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true));
        $data['breadcrumbs'][] = array('text' => $this->language->get('text_extension'), 'href' => $this->url->link('marketplace/extensions', 'user_token=' . $this->session->data['user_token'] . $url, true));
        $data['breadcrumbs'][] = array('text' => $this->language->get('heading_title'), 'href' => $this->url->link('extension/payment/possia', 'user_token=' . $this->session->data['user_token'] . $url, true));
        $data['breadcrumbs'][] = array('text' => $this->language->get('possia_transactions_list'), 'href' => $this->url->link('extension/payment/possia', 'user_token=' . $this->session->data['user_token'] . $url, true));

        $data['orders'] = array();

        $filter_data = array(
            'filter_order_id'        => $filter_order_id,
            'filter_customer'	     => $filter_customer,
            'filter_order_status'    => $filter_order_status,
            'filter_order_status_id' => $filter_order_status_id,
            'filter_total'           => $filter_total,
            'filter_date_added'      => $filter_date_added,
            'filter_date_modified'   => $filter_date_modified,
            'filter_transaction_comment'   => $filter_transaction_comment,
            'sort'                   => $sort,
            'order'                  => $order,
            'start'                  => ($page - 1) * $LimitPage,
            'limit'                  => $LimitPage
        );

        $order_total = $this->model_extension_payment_possia->getTotalOrders($filter_data);

        $results = $this->model_extension_payment_possia->getOrders($filter_data);

        foreach ($results as $result) {
            $data['orders'][] = array(
                'order_id'      => $result['order_id'],
                'customer'      => $result['customer'],
                'order_status'  => $result['order_status'] ? $result['order_status'] : $this->language->get('text_missing'),
                'total'         => $this->currency->format($result['total'], $result['currency_code'], $result['currency_value']),
                'date_added'    => date($this->language->get('date_format_short'), strtotime($result['date_added'])),
                'date_modified' => date($this->language->get('date_format_short'), strtotime($result['date_modified'])),
                'shipping_code' => $result['shipping_code'],
                'payment_code'   => $result['payment_code'],
                'transaction_comment'   => $result['transaction_comment'],
                'view'          => $this->url->link('sale/order/info', 'user_token=' . $this->session->data['user_token'] . '&order_id=' . $result['order_id'] . $url, true),
                'edit'          => $this->url->link('sale/order/edit', 'user_token=' . $this->session->data['user_token'] . '&order_id=' . $result['order_id'] . $url, true)
            );
        }

        $data['user_token'] = $this->session->data['user_token'];

        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset($this->session->data['success'])) {
            $data['success'] = $this->session->data['success'];

            unset($this->session->data['success']);
        } else {
            $data['success'] = '';
        }

        if (isset($this->request->post['selected'])) {
            $data['selected'] = (array)$this->request->post['selected'];
        } else {
            $data['selected'] = array();
        }


        /**
         * GESTIONE URL PER SORT DATA TABELLA
         */
        $url = $this->generateQueryString_Filter();
        if ($order == 'ASC') {
            $url .= '&order=DESC';
        } else {
            $url .= '&order=ASC';
        }

        if (isset($this->request->get['page'])) {
            $url .= '&page=' . $this->request->get['page'];
        }

        $data['sort_order'] = $this->url->link('extension/payment/possia/transactionsList', 'user_token=' . $this->session->data['user_token'] . '&sort=o.order_id' . $url, true);
        $data['sort_customer'] = $this->url->link('extension/payment/possia/transactionsList', 'user_token=' . $this->session->data['user_token'] . '&sort=customer' . $url, true);
        $data['sort_status'] = $this->url->link('extension/payment/possia/transactionsList', 'user_token=' . $this->session->data['user_token'] . '&sort=order_status' . $url, true);
        $data['sort_total'] = $this->url->link('extension/payment/possia/transactionsList', 'user_token=' . $this->session->data['user_token'] . '&sort=o.total' . $url, true);
        $data['sort_date_added'] = $this->url->link('extension/payment/possia/transactionsList', 'user_token=' . $this->session->data['user_token'] . '&sort=o.date_added' . $url, true);
        $data['sort_date_added'] = $this->url->link('extension/payment/possia/transactionsList', 'user_token=' . $this->session->data['user_token'] . '&sort=o.date_added' . $url, true);
        $data['sort_date_modified'] = $this->url->link('extension/payment/possia/transactionsList', 'user_token=' . $this->session->data['user_token'] . '&sort=o.date_modified' . $url, true);

        $data['link_export_csv'] = $this->url->link('extension/payment/possia/exportCsv', 'user_token=' . $this->session->data['user_token']  . $url, true);

        /**
         * GESTIONE URL
         */
        $url = $this->generateQueryString_Filter();
        if (isset($this->request->get['sort'])) {
            $url .= '&sort=' . $this->request->get['sort'];
        }

        if (isset($this->request->get['order'])) {
            $url .= '&order=' . $this->request->get['order'];
        }
        $pagination = new Pagination();
        $pagination->total = $order_total;
        $pagination->page = $page;


        $pagination->limit = $LimitPage;
        $pagination->url = $this->url->link('extension/payment/possia/transactionsList', 'user_token=' . $this->session->data['user_token'] . $url . '&page={page}', true);


        $data['pagination'] = $pagination->render();

        $data['results'] = sprintf($this->language->get('text_pagination'), ($order_total) ? (($page - 1) * $LimitPage) + 1 : 0, ((($page - 1) * $LimitPage) > ($order_total - $LimitPage)) ? $order_total : ((($page - 1) * $LimitPage) + $LimitPage), $order_total, ceil($order_total / $LimitPage));

        $data['filter_order_id'] = $filter_order_id;
        $data['filter_customer'] = $filter_customer;
        $data['filter_order_status'] = $filter_order_status;
        $data['filter_order_status_id'] = $filter_order_status_id;
        $data['filter_total'] = $filter_total;
        $data['filter_date_added'] = $filter_date_added;
        $data['filter_date_modified'] = $filter_date_modified;
        $data['filter_transaction_comment'] = $filter_transaction_comment;

        $data['sort'] = $sort;
        $data['order'] = $order;

        $this->load->model('localisation/order_status');

        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        $data['api_token'] = '';

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/payment/possia_transactions_list', $data));
    }

    public function exportCsv() {
        $this->load->language('extension/payment/possia');
        $this->load->model('extension/payment/possia');



        if (isset($this->request->get['filter_order_id'])) {
            $filter_order_id = $this->request->get['filter_order_id'];
        } else {
            $filter_order_id = '';
        }

        if (isset($this->request->get['filter_customer'])) {
            $filter_customer = $this->request->get['filter_customer'];
        } else {
            $filter_customer = '';
        }

        if (isset($this->request->get['filter_order_status'])) {
            $filter_order_status = $this->request->get['filter_order_status'];
        } else {
            $filter_order_status = '';
        }

        if (isset($this->request->get['filter_order_status_id'])) {
            $filter_order_status_id = $this->request->get['filter_order_status_id'];
        } else {
            $filter_order_status_id = '';
        }


        if (isset($this->request->get['filter_total'])) {
            $filter_total = $this->request->get['filter_total'];
        } else {
            $filter_total = '';
        }

        if (isset($this->request->get['filter_date_added'])) {
            $filter_date_added = $this->request->get['filter_date_added'];
        } else {
            $filter_date_added = '';
        }

        if (isset($this->request->get['filter_date_modified'])) {
            $filter_date_modified = $this->request->get['filter_date_modified'];
        } else {
            $filter_date_modified = '';
        }

        if (isset($this->request->get['filter_transaction_comment'])) {
            $filter_transaction_comment = $this->request->get['filter_transaction_comment'];
        } else {
            $filter_transaction_comment = '';
        }

        if (isset($this->request->get['sort'])) {
            $sort = $this->request->get['sort'];
        } else {
            $sort = 'o.ORDER DATA';
        }

        if (isset($this->request->get['order'])) {
            $order = $this->request->get['order'];
        } else {
            $order = 'DESC';
        }

        $filter_data = array(
            'filter_order_id'        => $filter_order_id,
            'filter_customer'	     => $filter_customer,
            'filter_order_status'    => $filter_order_status,
            'filter_order_status_id' => $filter_order_status_id,
            'filter_total'           => $filter_total,
            'filter_date_added'      => $filter_date_added,
            'filter_date_modified'   => $filter_date_modified,
            'filter_transaction_comment'   => $filter_transaction_comment,
            'sort'                   => $sort,
            'order'                  => $order,
            'start'                  => 0,
            'limit'                  => 2000000
        );

        $results = $this->model_extension_payment_possia->getOrders($filter_data);


        $out = "";
        $out .= $this->language->get('tl_column_order_id') . ',';
        $out .= $this->language->get('tl_column_customer') . ',';
        $out .= $this->language->get('tl_column_status') . ',';
        $out .= $this->language->get('tl_column_total') . ',';
        $out .= $this->language->get('tl_column_currency') . ',';
        $out .= $this->language->get('tl_column_date_added') . ',';
        $out .= $this->language->get('tl_column_date_modified') . ',';
        $out .= $this->language->get('tl_column_transaction_comment');
        $out .="\n";

        foreach ($results as $result) {
            $out.= $result['order_id'].',';
            $out.= $result['customer'].',';
            $out.= ($result['order_status'] ? $result['order_status'] : $this->language->get('text_missing')).',';
            $out.= '"'.$this->currency->format($result['total'], $result['currency_code'], $result['currency_value'],false).'",';
            $out.= $result['currency_code'] .",";
            $out.= date($this->language->get('date_format_short'), strtotime($result['date_added'])).',';
            $out.= date($this->language->get('date_format_short'), strtotime($result['date_modified'])).",";
            $out.= '"'.$result['transaction_comment'] .'"';
            $out .="\n";
        }

        $this->response->addheader("Content-Encoding: UTF-8");
        $this->response->addheader("content-type: text/csv; charset=UTF-8");
        $this->response->addheader('Content-Disposition: attachment; filename="' . $this->model_extension_payment_possia->getMethodCode().'_'.date('ymdhis') . '.csv"');
        $this->response->addheader('Expires: 0');
        $this->response->addheader('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        $this->response->addheader('Pragma: public');
        $this->response->addheader('Content-Length: ' . strlen($out));

        $this->response->setOutput($out);
    }
    // Install module
    public function install() {
        $this->load->model('extension/payment/possia');
        $this->model_extension_payment_possia->install();
        //$this->model_extension_payment_possia->log('CIAO');
    }

    // Uninstall module
    public function uninstall() {
        $this->load->model('extension/payment/possia');
        $this->model_extension_payment_possia->uninstall();
    }
}