<?php

/**
 * Class ModelExtensionPaymentPossia
 *
 * WARNING, se si cambiano i valori delle costanti qui devono essere cambiati anche qui -> catalog/model/extension/payment/possia.php
 */

class ModelExtensionPaymentPossia extends Model {

    /**
     * Unique method code
     *
     * WARNING, se si cambia il valore qui deve essere cambiato anche qui -> catalog/model/extension/payment/possia.php
     */
    const METHOD_CODE = "possia";

    const PLUGIN_VERSION ="Beta.5";

    //Mode
    const PAYMENT_POSSIA_MODE_TEST = "T";
    const PAYMENT_POSSIA_MODE_PRODUCTION = "P";

    // Accounting
    const PAYMENT_POSSIA_TRANSACTION_IMMEDIATE = "I";
    const PAYMENT_POSSIA_TRANSACTION_DIFFERITE = "D";

    // Status
    const PAYMENT_POSSIA_ENABLED = 1;
    const PAYMENT_POSSIA_DISABLED = 0;

    // Status
    const PAYMENT_POSSIA_LOG_ENABLED = 1;
    const PAYMENT_POSSIA_LOG_DISABLED = 0;

    // Languages for portal
    const PAYMENT_POSSIA_LANGUAGE_EN = "EN";
    const PAYMENT_POSSIA_LANGUAGE_IT = "IT";
    const PAYMENT_POSSIA_LANGUAGE_EL = "EL";
    const PAYMENT_POSSIA_LANGUAGE_SR = "SR";
    const PAYMENT_POSSIA_LANGUAGE_SK = "SK";

    // Test default parameters
    const PAYMENT_POSSIA_TEST_GATEWAY_URL = 'https://virtualpostest.sia.eu/vpos/payments/main?PAGE=LAND';
    /*const PAYMENT_POSSIA_TEST_SHOP_ID = '1292812928P0001';
    const PAYMENT_POSSIA_TEST_STARTER_KEY= 'gH-ABTTNg-B66az--cqfUsuCksf-3jB3pv3N7x-TpX3dDVg--9GQ-nYFCU365K6T-26vSR6wCRrWffwXkZ-PDbBUp3MdhwUZ-CV3';
    const PAYMENT_POSSIA_TEST_OUTCOME_KEY= 'yzUF-y5AAt-Y4QL-aJeqWaYJAHZx2-un-sC66-7VNAFR-W-uQJRLbv-Qj-Wbnuc-vXsmefU39a6MyuVqzb2-8-tYC-GZUw52Qzjv';*/
    /* TEST NEGOZIO ESTERO */
    const PAYMENT_POSSIA_TEST_SHOP_ID = '80729SE99999999';
    const PAYMENT_POSSIA_TEST_STARTER_KEY= 'YK76Fkqheec4dDKAmESLp---esPbwFj--2tkJHr73KDxtgpX-Lu6--vuGFXYRNLQXXvVFh96sDSvew-rpY-kAmQzZMDdCM-qnfs-';
    const PAYMENT_POSSIA_TEST_OUTCOME_KEY= 'aph3-LxfpVvPe3nU3atEg4G4-Sn-uXc-F6-g22keKgMP6TZPMY4AYcbCWjsBN2anJ--zDpRGYEBTaG-WkjtJAGL-n4ShNQUKsENX';



    // Production default parameters
    const PAYMENT_POSSIA_PRODUCTION_GATEWAY_URL = 'https://virtualpos.sia.eu/vpos/payments/main?PAGE=LAND';


    //Link al VPORTAL SIA
    const PAYMENT_POSSIA_VPORTAL_TEST = 'https://atpostest.ssb.it/cubo/fgu-apl/AF06/main.app?FUNCTIONID=Login';
    const PAYMENT_POSSIA_VPORTAL_PRODUCTION = 'https://atpos.ssb.it/cubo/fgu-apl/start-atpos.html';

    //Link transactions list
    const PAYMENT_POSSIA_TRANSACTIONS_LIST_LINK = 'extension/payment/possia/transactionsList';

    /**
     * Plugin version
     *
     * @return string
     */
    public function getVersion() {
        return self::PLUGIN_VERSION;
    }
	public function getTest_GatewayUrl() {
		return self::PAYMENT_POSSIA_TEST_GATEWAY_URL;
	}

	public function getTest_ShopId() {
        return self::PAYMENT_POSSIA_TEST_SHOP_ID;
    }
    public function getTest_StarterKey() {
        return self::PAYMENT_POSSIA_TEST_STARTER_KEY;
    }

    public function getTest_OutcomeKey() {
        return self::PAYMENT_POSSIA_TEST_OUTCOME_KEY;
    }

    public function getProduction_GatewayUrl() {
        return self::PAYMENT_POSSIA_PRODUCTION_GATEWAY_URL;
    }

    public function getProduction_ShopId() {
        return $this->config->get('payment_possia_production_shop_id');
    }

    public function getProduction_StarterKey() {
        return $this->config->get('payment_possia_production_starter_key');
    }

    public function getProduction_OutcomeKey() {
        return $this->config->get('payment_possia_production_outcome_key');
    }

    public function isProductionMode($mode) {
        return  ($mode == self::PAYMENT_POSSIA_MODE_PRODUCTION);
    }

    public function getVPORTAL_Link_Test() {
	    return self::PAYMENT_POSSIA_VPORTAL_TEST;
    }

    public function getVPORTAL_Link_Production() {
	    return self::PAYMENT_POSSIA_VPORTAL_PRODUCTION;
    }

    public function get_transactions_list_Link() {
	    return self::PAYMENT_POSSIA_TRANSACTIONS_LIST_LINK;
    }

    /**
     * @return string
     */
    public function getMethodCode() {
        return self::METHOD_CODE;
    }
    /**
     * Write log
     * @param      $data
     * @param null $title
     */
    public function log($data, $title = null) {
		if ($this->config->get('payment_possia_enable_log')) {
			$log = new Log('possia.log');
			$log->write('PosSia Admin Area - debug (' . $title . '): ' . json_encode($data));
		}
	}

    /**
     * Called when extension install procedure
     */
    public function install() {
        $this->load->model('setting/setting');

        $defaults = array();


        // Order Status defaults
        $defaults['payment_possia_mode'] = self::PAYMENT_POSSIA_MODE_TEST;
        $defaults['payment_possia_transaction'] = self::PAYMENT_POSSIA_TRANSACTION_IMMEDIATE;
        $defaults['payment_possia_language'] = self::PAYMENT_POSSIA_LANGUAGE_EN;
        $defaults['payment_possia_paid_order_status_id'] = 2; // Status processing
        $defaults['payment_possia_notpaid_order_status_id'] = 1; // Peding
        $defaults['payment_possia_status'] = self::PAYMENT_POSSIA_ENABLED;

        $defaults['payment_possia_sort_order'] = 1;
        $defaults['payment_possia_enable_log'] = self::PAYMENT_POSSIA_LOG_ENABLED;
        $defaults['payment_possia_test_gateway_url'] = self::PAYMENT_POSSIA_TEST_GATEWAY_URL;
        $defaults['payment_possia_test_shop_id'] = self::PAYMENT_POSSIA_TEST_SHOP_ID;
        $defaults['payment_possia_test_starter_key'] = self::PAYMENT_POSSIA_TEST_STARTER_KEY;
        $defaults['payment_possia_test_outcome_key'] = self::PAYMENT_POSSIA_TEST_OUTCOME_KEY;
        $defaults['payment_possia_production_gateway_url'] = self::PAYMENT_POSSIA_PRODUCTION_GATEWAY_URL;
        $defaults['payment_possia_production_shop_id'] = '';
        $defaults['payment_possia_production_starter_key'] = '';
        $defaults['payment_possia_production_outcome_key'] = '';

        $this->model_setting_setting->editSetting('payment_possia', $defaults);
    }

    /**
     *
     */
    public function uninstall() {
        $this->load->model('setting/setting');

        $defaults = array();

        // Order Status defaults
        $defaults['payment_possia_mode'] = self::PAYMENT_POSSIA_MODE_TEST;
        $defaults['payment_possia_transaction'] = self::PAYMENT_POSSIA_TRANSACTION_IMMEDIATE;
        $defaults['payment_possia_language'] = self::PAYMENT_POSSIA_LANGUAGE_EN;
        $defaults['payment_possia_status'] = self::PAYMENT_POSSIA_DISABLED;

        $defaults['payment_possia_sort_order'] = 1;
        $defaults['payment_possia_enable_log'] = self::PAYMENT_POSSIA_LOG_DISABLED;
        $defaults['payment_possia_test_gateway_url'] = '';
        $defaults['payment_possia_test_shop_id'] = '';
        $defaults['payment_possia_test_starter_key'] = '';
        $defaults['payment_possia_test_outcome_key'] = '';
        $defaults['payment_possia_production_gateway_url'] ='';
        $defaults['payment_possia_production_shop_id'] = '';
        $defaults['payment_possia_production_starter_key'] = '';
        $defaults['payment_possia_production_outcome_key'] = '';

    }

    private function createWhere($data = array()) {
        $sqlWhere = "";
        if (!empty($data['filter_order_status'])) {
            $implode = array();

            $order_statuses = explode(',', $data['filter_order_status']);

            foreach ($order_statuses as $order_status_id) {
                $implode[] = "o.order_status_id = '" . (int)$order_status_id . "'";
            }

            if ($implode) {
                $sqlWhere .= " WHERE (" . implode(" OR ", $implode) . ")";
            }
        } elseif (isset($data['filter_order_status_id']) && $data['filter_order_status_id'] !== '') {
            $sqlWhere .= " WHERE o.order_status_id = '" . (int)$data['filter_order_status_id'] . "'";
        } else {
            $sqlWhere .= " WHERE o.order_status_id > '0'";
        }

        $sqlWhere .= " AND o.payment_code = '" . $this->getMethodCode() . "' ";

        if (!empty($data['filter_order_id'])) {
            $sqlWhere .= " AND o.order_id = '" . (int)$data['filter_order_id'] . "'";
        }

        if (!empty($data['filter_customer'])) {
            $sqlWhere .= " AND CONCAT(o.firstname, ' ', o.lastname) LIKE '%" . $this->db->escape($data['filter_customer']) . "%'";
        }

        if (!empty($data['filter_date_added'])) {
            $sqlWhere .= " AND DATE(o.date_added) = DATE('" . $this->db->escape($data['filter_date_added']) . "')";
        }

        if (!empty($data['filter_date_modified'])) {
            $sqlWhere .= " AND DATE(o.date_modified) = DATE('" . $this->db->escape($data['filter_date_modified']) . "')";
        }

        if (!empty($data['filter_total'])) {
            $sqlWhere .= " AND o.total = '" . (float)$data['filter_total'] . "'";
        }

        if (!empty($data['filter_transaction_comment'])) {
            $sqlWhere .= " AND ooh.comment like '%".$this->db->escape($data['filter_transaction_comment'])."%'";
        }

        if (!empty($data['filter_total'])) {
            $sqlWhere .= " AND o.total = '" . (float)$data['filter_total'] . "'";
        }
        return $sqlWhere;
    }

    public function getTotalOrders($data = array()) {
        $sql = "SELECT COUNT(*) AS total FROM `" . DB_PREFIX . "order` o LEFT OUTER JOIN `" . DB_PREFIX . "order_history` ooh ON (o.order_id = ooh.order_id and ooh.comment like '%AUTHNUMBER%') ";
        $sql .= $this->createWhere($data);


        $query = $this->db->query($sql);

        return $query->row['total'];
    }

    public function getOrders($data = array()) {
        $sql = "SELECT o.order_id, 
       CONCAT(o.firstname, ' ', o.lastname) AS customer, 
       (SELECT os.name FROM " . DB_PREFIX . "order_status os WHERE os.order_status_id = o.order_status_id AND os.language_id = '" . (int)$this->config->get('config_language_id') . "') AS order_status, 
       o.shipping_code, o.total, 
       o.currency_code, o.currency_value, o.date_added, o.date_modified, o.payment_code, 
       ooh.comment as transaction_comment  
       FROM `" . DB_PREFIX . "order` o LEFT OUTER JOIN `" . DB_PREFIX . "order_history` ooh ON (o.order_id = ooh.order_id and ooh.comment like '%AUTHNUMBER%') ";

        $sql .= $this->createWhere($data);

        $sort_data = array(
            'o.order_id',
            'customer',
            'o.date_added',
            'o.total'
        );

        if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
            $sql .= " ORDER BY " . $data['sort'];
        } else {
            $sql .= " ORDER BY o.order_id";
        }

        if (isset($data['order']) && ($data['order'] == 'DESC')) {
            $sql .= " DESC";
        } else {
            $sql .= " ASC";
        }

        if (isset($data['start']) || isset($data['limit'])) {
            if ($data['start'] < 0) {
                $data['start'] = 0;
            }

            if ($data['limit'] < 1) {
                $data['limit'] = 20;
            }

            $sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
        }

        $query = $this->db->query($sql);

        return $query->rows;
    }
}