<?php

//As our file is possia.php so Class name is ControllerExtensionPaymentPossia which extends the Controller base class
class ControllerExtensionPaymentPossia extends Controller
{
    //Create index method. Index method is called automatically if no parameters are passed,
    // check this video tutorial for details https://www.youtube.com/watch?v=X6bsMmReT-4.
    //In payment extension you don't need to pass any parameter in index() method.
    public function index ()
    {
        //Loads the language file by which the varaibles of language file are accessible in twig files
        $this->load->language('extension/payment/possia');

        //Text to show for the button.
        $data['button_confirm'] = $this->language->get('button_confirm');
        //Get the configured value, and find when it is on test mode or not.

        $data['payment_possia_mode'] = $this->config->get('payment_possia_mode');
        //Text to show when it is in test mode.
        $data['text_testmode'] = $this->language->get('text_testmode');

        $this->load->model('checkout/order');
        $this->load->model('extension/payment/possia');

        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        $strUniqueLog = $this->model_extension_payment_possia->getRandomLogId(10, 'orderid_' . $this->session->data['order_id'] . "__");
        $this->model_extension_payment_possia->logDebug('');
        $this->model_extension_payment_possia->logDebug('----- BEGIN form payment order_id: ' . $this->session->data['order_id'], $strUniqueLog);
        if ($order_info) {
            $data['business'] = $this->config->get('payment_possia_merchant_id');
            $data['item_name'] = html_entity_decode($this->config->get('config_name'), ENT_QUOTES, 'UTF-8');

            $data['text_submit'] = $this->language->get('possia_pay_via');
            $data['products'] = array ();

            // Get the products of the Cart
            foreach ($this->cart->getProducts() as $product) {
                $option_data = array ();

                foreach ($product['option'] as $option) {
                    if ($option['type'] != 'file') {
                        $value = $option['value'];
                    } else {
                        $upload_info = $this->model_tool_upload->getUploadByCode($option['value']);

                        if ($upload_info) {
                            $value = $upload_info['name'];
                        } else {
                            $value = '';
                        }
                    }

                    $option_data[] = array (
                        'name' => $option['name'],
                        'value' => (utf8_strlen($value) > 20 ? utf8_substr($value, 0, 20) . '..' : $value),
                    );
                }

                $data['products'][] = array (
                    'name' => htmlspecialchars($product['name']),
                    'model' => htmlspecialchars($product['model']),
                    'price' => $this->currency->format($product['price'], $order_info['currency_code'], '', FALSE),
                    'quantity' => $product['quantity'],
                    'option' => $option_data,
                    'weight' => $product['weight'],
                );
            }

            $data['discount_amount_cart'] = 0;

            $total = $this->currency->format($order_info['total'] - $this->cart->getSubTotal(), $order_info['currency_code'], '', FALSE);

            if ($total > 0) {
                $data['products'][] = array (
                    'name' => $this->language->get('text_total'),
                    'model' => '',
                    'price' => $total,
                    'quantity' => 1,
                    'option' => array (),
                    'weight' => 0,
                );
            } else {
                $data['discount_amount_cart'] -= $total;
            }


            // Prepare Data for Sia Gateway
            //If it is on test mode then set the form action URL to sandbox possia URL else set the form action URL to live possia URL
            $data['action'] = ($this->config->get('payment_possia_mode') == "P" ? $this->config->get('payment_possia_production_gateway_url') : $this->config->get('payment_possia_test_gateway_url'));

            //$data['AMOUNT'] = str_replace(".", "", $this->currency->format($order_info['total'], $order_info['currency_code'], '', FALSE));
            $__AMOUNT = $this->currency->format($order_info['total'], $order_info['currency_code'], '', FALSE) . '';
            $__AMOUNT_EXPLODED = explode(".", $__AMOUNT);
            if (count($__AMOUNT_EXPLODED) == 1) {
                $data['AMOUNT'] = $__AMOUNT_EXPLODED[0] . str_pad('', $this->currency->getDecimalPlace($order_info['currency_code']), "0");
            } else {
                $data['AMOUNT'] = $__AMOUNT_EXPLODED[0] . str_pad($__AMOUNT_EXPLODED[1], $this->currency->getDecimalPlace($order_info['currency_code']), "0");
            }

            $data['CURRENCY'] = $this->model_extension_payment_possia->get_currencies_number_from_code($order_info['currency_code']);
            /**
             * estract exponent from total number after dot
             */
            list($intVal, $decimalVal) = explode(".", $order_info['total']);
            $data['EXPONENT'] = $this->currency->getDecimalPlace($order_info['currency_code']);
            $data['ORDERID'] = $order_info['order_id'];

            $data['SHOPID'] = ($this->config->get('payment_possia_mode') == "P" ? $this->config->get('payment_possia_production_shop_id') : $this->config->get('payment_possia_test_shop_id'));


            //Customer E-Mail
            $data['EMAIL'] = $order_info["email"];

            $data['URLBACK'] = $this->url->link('checkout/checkout', '', TRUE);
            $data['URLDONE'] = $this->url->link('extension/payment/possia/urldone', '', TRUE);
            $data['URLMS'] = $this->url->link('extension/payment/possia/urlms', '', TRUE);

            $data['ACCOUNTINGMODE'] = $this->config->get('payment_possia_transaction');
            /**
             * L'autorizzazione non è settabile dall'utente è deve sempre essere immediata
             */
            $data['AUTHORMODE'] = "I";

            /**
             * If authorization is granted, the system will not show the outcome of the transaction to the consumer, but rather, it will immediately redirect the latter to the URLDONE so as to enable the virtual store to show its own customized “receipt”. If authorization is denied to the user, the “enter your card” screen will be displayed again.
             */
            $data['OPTIONS'] = "G";
            $data['LOCKCARD'] = "";
            $data['LANG'] = $this->config->get('payment_possia_language');;

            //$data['TREDSDATA'] = $this->generate3DSDATA($order_info,
            $data['3DSDATA'] = $this->generate3DSDATA($order_info,
                ($this->config->get('payment_possia_mode') == "P" ? $this->config->get('payment_possia_production_outcome_key') : $this->config->get('payment_possia_test_outcome_key')));


            $ordDescr = $this->config->get('config_name') . '- Order N. ' . $data['ORDERID'];

            $data['MAC'] = $this->generateMAC_request($data['URLMS'], $data['URLDONE'], $data['ORDERID'], $data['SHOPID'], $data['AMOUNT'], $data['CURRENCY'], $data['EXPONENT'],
                $data['ACCOUNTINGMODE'], $data['AUTHORMODE'],
                $order_info["payment_firstname"],
                $order_info["payment_lastname"],
                $ordDescr,
                ($this->config->get('payment_possia_mode') == "P" ? $this->config->get('payment_possia_production_starter_key') : $this->config->get('payment_possia_test_starter_key')),
                $data['LOCKCARD'],
                $data['OPTIONS']
                , $data['3DSDATA']
            );


            $data['custom'] = $this->session->data['order_id'];

            $this->writeFormDataIntoLog($data, $strUniqueLog);

            $this->model_extension_payment_possia->logDebug('----- END form payment order_id: ' . $this->session->data['order_id'], $strUniqueLog);

            /**
             * For twig template
             */
            $data['TREDSDATA'] = $data['3DSDATA'];
            return $this->load->view('extension/payment/possia', $data);
        } else {
            $this->model_extension_payment_possia->logDebug("ERROR NO ID PRESENT ON THE SYSTEM");
            $this->model_extension_payment_possia->logDebug('----- END form payment order_id: ' . $this->session->data['order_id'], $strUniqueLog);
        }
    }


    /**
     * WRITE SIA PARAMTERS
     *
     * @param array  $data         array dei dati inviati dal form
     * @param string $strUniqueLog stringa univoca del log
     */
    private function writeFormDataIntoLog ($data, $strUniqueLog)
    {
        $this->writeFormDataIntoLog_products($data["products"], $strUniqueLog);

        //foreach(array('EXPONENT','ORDERID','SHOPID','URLBACK','URLDONE','URLMS','ACCOUNTINGMODE','AUTHORMODE','OPTIONS','LOCKCARD','LANG','TREDSDATA','MAC') as $V) {
        foreach (array ('EXPONENT', 'ORDERID', 'SHOPID', 'URLBACK', 'URLDONE', 'URLMS', 'ACCOUNTINGMODE', 'AUTHORMODE', 'OPTIONS', 'LOCKCARD', 'LANG', '3DSDATA', 'MAC', 'EMAIL') as $V) {
            $this->model_extension_payment_possia->logDebug($V . ": " . $data[$V], $strUniqueLog);
        }
    }

    private function writeFormDataIntoLog_products ($data, $strUniqueLog, $strChild = "")
    {

        foreach ($data as $pk => $pv) {
            if (is_array($pv)) {
                $this->model_extension_payment_possia->logDebug($strChild . " " . $pk . ": ", $strUniqueLog);
                $this->writeFormDataIntoLog_products($pv, $strUniqueLog, $strChild . "-- ");
            } else {
                $this->model_extension_payment_possia->logDebug($strChild . " " . $pk . ": " . $pv, $strUniqueLog);
            }
        }
    }

    /**
     * Obtain Parameters from QueryString
     *
     * @param      $key
     * @param null $default
     *
     * @return mixed|null
     */
    private function getQueryStringParameter ($key, $default = NULL)
    {
        if (array_key_exists($key, $_GET)) {
            return $_GET[$key];
        }
        return $default;
    }

    /**
     * Estrae  i parametri dalla risposta del gateway
     *
     * @param $strUniqueLog
     *
     * @return array[]
     */
    private function getGatewayResponse ($strUniqueLog)
    {
        $orderid = $this->getQueryStringParameter('ORDERID');
        $shopid = $this->getQueryStringParameter("SHOPID");
        $authnumber = $this->getQueryStringParameter("AUTHNUMBER");  //(if the authorization is not present, the field will have the value of “NULL")
        $amount = $this->getQueryStringParameter("AMOUNT");
        $currency = $this->getQueryStringParameter("CURRENCY");
        $exponent = $this->getQueryStringParameter("EXPONENT");
        $network = $this->getQueryStringParameter("NETWORK");
        $transactionid = $this->getQueryStringParameter("TRANSACTIONID");
        $accountingmode = $this->getQueryStringParameter("ACCOUNTINGMODE");
        $authormode = $this->getQueryStringParameter("AUTHORMODE");
        $result = $this->getQueryStringParameter("RESULT");
        $transactiontype = $this->getQueryStringParameter("TRANSACTIONTYPE");
        $issuercountry = $this->getQueryStringParameter("ISSUERCOUNTRY");
        $mac = $this->getQueryStringParameter("MAC");

        $payerid = $this->getQueryStringParameter("PAYERID");
        $payer = $this->getQueryStringParameter("PAYER");
        $payerstatus = $this->getQueryStringParameter("PAYERSTATUS");
        $hashpan = $this->getQueryStringParameter("HASHPAN");
        $iban = $this->getQueryStringParameter("IBAN");
        $accountholder = $this->getQueryStringParameter("ACCOUNTHOLDER");
        $aliasstr = $this->getQueryStringParameter("ALIASSTR");
        $pantail = $this->getQueryStringParameter("PANTAIL");
        $panexpirydate = $this->getQueryStringParameter("PANEXPIRYDATE");
        $panalias = $this->getQueryStringParameter("PANALIAS");
        $panaliasrev = $this->getQueryStringParameter("PANALIASREV");
        $panaliasexpdate = $this->getQueryStringParameter("PANALIASEXPDATE");
        $panaliastail = $this->getQueryStringParameter("PANALIASTAIL");
        $maskedpan = $this->getQueryStringParameter("MASKEDPAN");
        $acquirerbin = $this->getQueryStringParameter("ACQUIRERBIN");
        $merchantid = $this->getQueryStringParameter("MERCHANTID");
        $cardtype = $this->getQueryStringParameter("CARDTYPE");

        $macOutcome = $this->generateMAC_outcome($orderid, $shopid, $authnumber, $amount, $currency, $exponent, $transactionid, $accountingmode, $authormode, $result, $transactiontype, $issuercountry
            , $payerid
            , $payer
            , $payerstatus
            , $hashpan
            , $iban
            , $accountholder
            , $aliasstr
            , $pantail
            , $panexpirydate
            , $panalias
            , $panaliasrev
            , $panaliasexpdate
            , $panaliastail
            , $maskedpan
            , $acquirerbin
            , $merchantid
            , $cardtype
            , ($this->config->get('payment_possia_mode') == "P" ? $this->config->get('payment_possia_production_outcome_key') : $this->config->get('payment_possia_test_outcome_key')));

        // Construct variables for transaction response
        $data_outcome = [];
        $data_outcome['AMOUNT'] = $amount;
        $data_outcome['CURRENCY'] = $currency;
        //number of decimals for the currency (present only if option=x or currency not euro
        $data_outcome['EXPONENT'] = $exponent;
        $data_outcome['NETWORK'] = $network;
        $data_outcome['ORDERID'] = $orderid;
        // Merchant details
        $data_outcome['SHOPID'] = $shopid;
        //$data_outcome['URLBACK'] = $urlBack;
        //$data_outcome['URLDONE'] = $this->urldone;
        //$data_outcome['URLMS'] = $this->url_ums;
        $data_outcome['ACCOUNTINGMODE'] = $accountingmode;
        $data_outcome['AUTHORMODE'] = $authormode;
        $data_outcome['AUTHNUMBER'] = $authnumber;
        $data_outcome['TRANSACTIONID'] = $transactionid;
        $data_outcome['TRANSACTIONTYPE'] = $transactiontype;
        $data_outcome['RESULT'] = $result;
        $data_outcome['ISSUSERCOUNTRY'] = $issuercountry;
        $data_outcome['MAC'] = $mac;

        $data_outcome['PAYERID'] = $payerid;
        $data_outcome['PAYER'] = $payer;
        $data_outcome['PAYERSTATUS'] = $payerstatus;
        $data_outcome['HASHPAN'] = $hashpan;
        $data_outcome['IBAN'] = $iban;
        $data_outcome['ACCOUNTHOLDER'] = $accountholder;
        $data_outcome['ALIASSTR'] = $aliasstr;
        $data_outcome['PANTAIL'] = $pantail;
        $data_outcome['PANEXPIRYDATE'] = $panexpirydate;
        $data_outcome['PANALIAS'] = $panalias;
        $data_outcome['PANALIASREV'] = $panaliasrev;
        $data_outcome['PANALIASEXPDATE'] = $panaliasexpdate;
        $data_outcome['PANALIASTAIL'] = $panaliastail;
        $data_outcome['MASKEDPAN'] = $maskedpan;
        $data_outcome['ACQUIRERBIN'] = $acquirerbin;
        $data_outcome['MERCHANTID'] = $merchantid;
        $data_outcome['CARDTYPE'] = $cardtype;

        $data_outcome['MACOUTCOME'] = $macOutcome;
        if (!empty($options)) {
            $data_outcome['OPTIONS'] = $options;
        }
        if (!empty($lockcard)) {
            $data_outcome['LOCKCARD'] = $lockcard;
        }

        $this->model_extension_payment_possia->logDebug("OUTCOME DATA", $strUniqueLog);
        foreach ($data_outcome as $k => $v) {
            $this->model_extension_payment_possia->logDebug("-- " . $k . ": " . $v, $strUniqueLog);
        }

        return [
            "qs" => ['ORDERID' => $orderid, "SHOPID" => $shopid, "AUTHNUMBER" => $authnumber, "AMOUNT" => $amount, "CURRENCY" => $currency,
                "EXPONENT" => $exponent, "NETWORK" => $network, "TRANSACTIONID" => $transactionid,
                "ACCOUNTINGMODE" => $accountingmode, "AUTHORMODE" => $authormode, "RESULT" => $result, "TRANSACTIONTYPE" => $transactiontype,
                "ISSUERCOUNTRY" => $issuercountry, "MAC" => $mac, "MACOUTCOME" => $macOutcome],
            "data_outcome" => $data_outcome
        ];
    }

    /**
     * Check if the note has already been entered, in order to manage the order status change on URLDONE and URLMS calls
     *
     * @param $order_histories
     * @param $NoteToOrder
     *
     * @return bool
     */
    private function isOrderHistory_PaymenProcessed ($order_histories, $NoteToOrder)
    {
        foreach ($order_histories as $orderHistory) {
            if ($orderHistory["comment"] === $NoteToOrder) {
                return $orderHistory;
            }
        }
        return FALSE;
    }

    private function checkGatewayResponse ($strUniqueLog, $orderid, $result, $mac, $macoutcome,
                                           $authnumber,
                                           $transactionId,
                                           $transactionType,
                                           $writeOrderHistory = FALSE)
    {
        $order_info = $this->model_checkout_order->getOrder($orderid);
        $order_histories = $this->model_account_order->getOrderHistories($orderid);
        $thisMethodCode = $this->model_extension_payment_possia->getMethodCode();
        $transactionOk = FALSE;


        if ($order_info) {
            if ($order_info["payment_code"] == $thisMethodCode) {
                if ($result == "00") {
                    if ($mac === $macoutcome) {
                        //SUCCESS
                        //  $NoteToOrder = $this->language->get('transaction_payment_ok');
                        $NoteToOrder = sprintf($this->language->get('transaction_payment_ok'), $authnumber, $transactionId, $transactionType);

                        if (($OH = $this->isOrderHistory_PaymenProcessed($order_histories, $NoteToOrder)) === FALSE) {
                            //if ($writeOrderHistory) {
                            $this->model_checkout_order->addOrderHistory($orderid, $this->config->get('payment_possia_paid_order_status_id'), $NoteToOrder, TRUE);
                            $this->model_extension_payment_possia->logDebug("TRANSACTION PAYMENT OK: " . $NoteToOrder, $strUniqueLog);
                        } else {
                            $this->model_extension_payment_possia->logDebug("Payment transaction already occurred on: " . $OH["date_added"], $strUniqueLog);
                        }

                        $transactionOk = TRUE;
                    } else {
                        // Error
                        $NoteToOrder = $this->language->get('transaction_payment_ok_MAC_not_equals');
                        if (($OH = $this->isOrderHistory_PaymenProcessed($order_histories, $NoteToOrder)) === FALSE) {
                            //if ($writeOrderHistory) {
                            $this->model_checkout_order->addOrderHistory($orderid, $this->config->get('payment_possia_notpaid_order_status_id'), $NoteToOrder, TRUE);
                            $this->model_extension_payment_possia->logError("TRANSACTION PAYMENT ERROR: " . $NoteToOrder, $strUniqueLog);
                        } else {
                            $this->model_extension_payment_possia->logError("TRANSACTION PAYMENT ERROR ALREADY OCCURRED ON: " . $OH["date_added"], $strUniqueLog);
                        }

                    }
                } else {
                    // Error
                    $NoteToOrder = sprintf($this->language->get('transaction_payment_ko'), $result);
                    if (($OH = $this->isOrderHistory_PaymenProcessed($order_histories, $NoteToOrder)) === FALSE) {
                        //if ($writeOrderHistory) {
                        $this->model_checkout_order->addOrderHistory($orderid, $this->config->get('payment_possia_notpaid_order_status_id'), $NoteToOrder, TRUE);
                        $this->model_extension_payment_possia->logError("TRANSACTION PAYMENT ERROR: " . $NoteToOrder, $strUniqueLog);
                    } else {
                        $this->model_extension_payment_possia->logError("TRANSACTION PAYMENT ERROR ALREADY OCCURRED ON: " . $OH["date_added"], $strUniqueLog);
                    }
                }
            } else {
                $this->model_extension_payment_possia->logError("ORDER ID: $orderid NOT PAID WITH \"{$thisMethodCode}\" BUT \"{$order_info["payment_code"]}\"", $strUniqueLog);
            }

        } else {
            $this->model_extension_payment_possia->logError("ORDER ID: $orderid NOT EXISTS IN THE SYSTEM", $strUniqueLog);
        }

        return $transactionOk;
    }

    /**
     * Richiamata come redirect dal gateway al sito, qui controllo solo l'ordine e faccio il redirect poi su urlms cambio lo stato dell'ordine.
     */
    public function urldone ()
    {
        $this->load->language('extension/payment/possia');

        $this->load->model('checkout/order');
        $this->load->model('account/order');
        $this->load->model('extension/payment/possia');

        $curDate = date('Ymdhims');

        $orderid = $this->getQueryStringParameter('ORDERID');

        $strUniqueLog = $this->model_extension_payment_possia->getRandomLogId(5, 'done_' . $curDate . "_order_id_" . ($orderid != NULL ? $orderid : "NULL"));

        $this->model_extension_payment_possia->logDebug("");
        $this->model_extension_payment_possia->logDebug("----- BEGIN API Ending Point URLDONE", $strUniqueLog);
        $this->model_extension_payment_possia->logDebug("POST data: " . json_encode($this->request->post), $strUniqueLog);
        $this->model_extension_payment_possia->logDebug("GET data: " . json_encode($this->request->get), $strUniqueLog);

        $grd = $this->getGatewayResponse($strUniqueLog);
        $transactionOk = $this->checkGatewayResponse($strUniqueLog, $orderid, $grd['qs']['RESULT'], $grd['qs']['MAC'], $grd['qs']['MACOUTCOME'], $grd['qs']['AUTHNUMBER'], $grd['qs']['TRANSACTIONID'], $grd['qs']['TRANSACTIONTYPE'], TRUE);

        $this->model_extension_payment_possia->logDebug("----- END API Ending Point URLDONE", $strUniqueLog);

        if ($transactionOk == TRUE) {
            header("location: " . $this->url->link('checkout/success', '', TRUE));
        } else {
            header("location: " . $this->url->link('checkout/failed', '', TRUE));
        }
    }


    /**
     * API Ending Point URLMS, called when transaction it's ok or not ok from external Gateway
     */
    public function urlms ()
    {
        //sleep(1);
        $this->load->language('extension/payment/possia');
        $this->load->model('checkout/order');
        $this->load->model('account/order');
        $this->load->model('extension/payment/possia');

        $curDate = date('Ymdhims');

        $orderid = $this->getQueryStringParameter('ORDERID');

        $strUniqueLog = $this->model_extension_payment_possia->getRandomLogId(5, 'urlms_' . $curDate . "_order_id_" . ($orderid != NULL ? $orderid : "NULL"));

        $this->model_extension_payment_possia->logDebug("");
        $this->model_extension_payment_possia->logDebug("----- BEGIN API Ending Point URLMS", $strUniqueLog);
        $this->model_extension_payment_possia->logDebug("POST data: " . json_encode($this->request->post), $strUniqueLog);
        $this->model_extension_payment_possia->logDebug("GET data: " . json_encode($this->request->get), $strUniqueLog);

        $grd = $this->getGatewayResponse($strUniqueLog);
        $transactionOk = $this->checkGatewayResponse($strUniqueLog, $orderid, $grd['qs']['RESULT'], $grd['qs']['MAC'], $grd['qs']['MACOUTCOME'], $grd['qs']['AUTHNUMBER'], $grd['qs']['TRANSACTIONID'], $grd['qs']['TRANSACTIONTYPE'], TRUE);

        $this->model_extension_payment_possia->logDebug("----- END API Ending Point URLMS ", $strUniqueLog);

        /*   if ($transactionOk == true) {
               header("location: " . $this->url->link('checkout/success', '', TRUE));
           } else {
               header("location: " . $this->url->link('checkout/failed', '', TRUE));
           }
   */
    }

    /**
     * Return string encrypted
     *
     * @param WC_Order|WC_Order_Refund $order
     *
     * @return string
     */
    private function generate3DSDATA ($order, $outcome_key)
    {
        $ds = new \stdClass();

        /*        echo "<pre>";
                print_r($order);
                echo "</pre>";*/
        // Check address (Billing abd Shipping) match
        if (
            ($order["payment_firstname"] == $order["shipping_firstname"]) &&
            ($order["payment_lastname"] == $order["shipping_lastname"]) &&
            ($order["payment_company"] == $order["shipping_company"]) &&
            ($order["payment_country_id"] == $order["shipping_country_id"]) &&
            ($order["payment_address_1"] == $order["shipping_address_1"]) &&
            ($order["payment_address_2"] == $order["shipping_address_2"]) &&
            ($order["payment_postcode"] == $order["shipping_postcode"]) &&
            ($order["payment_city"] == $order["shipping_city"]) &&
            ($order["payment_zone_code"] == $order["shipping_zone_code"])) {
            $ds->addrMatch = "Y";
        } else {
            $ds->addrMatch = "N";
        }

        //  echo "ADDRESS MATCH ".$ds->addrMatch."<br>";

        //
        $ds->acctID = $order["customer_id"];

        //
        $ds->billAddrCity = $order["payment_city"];
        //  $ds->billAddrCountry = $order["payment_country_id"];
        $ds->billAddrLine1 = $order["payment_address_1"];
        $ds->billAddrPostCode = $order["payment_postcode"];
        //$ds->billAddrState = $order["payment_zone_code"];

        //
        if ($ds->addrMatch == "N") {
            $ds->shipAddrCity = $order["shipping_city"];
            //$ds->shipAddrCountry = $order["shipping_country_id"];
            $ds->shipAddrLine1 = $order["shipping_address_1"];
            $ds->shipAddrPostCode = $order["shipping_postcode"];
            //$ds->shipAddrState = $order["shipping_zone_code"];
        }

        $JSON = json_encode($ds);

        return $this->encrypt($JSON, $outcome_key);
    }

    private function encrypt ($json, $password)
    {
        $method = "AES-128-CBC";
        $key = $this->substr($password, 0, 16);

        $iv = "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";

        $ciphertext = openssl_encrypt($json, $method, $key, OPENSSL_RAW_DATA, $iv);

        $result = base64_encode($ciphertext);

        return $result;
    }

    private function substr ($str, $start, $length = FALSE, $encoding = 'utf-8')
    {
        if (is_array($str))
            return FALSE;
        if (function_exists('mb_substr'))
            return mb_substr($str, intval($start), ($length === FALSE ? $this->strlen($str) : intval($length)), $encoding);
        return substr($str, $start, ($length === FALSE ? strlen($str) : intval($length)));
    }

    private function strlen ($str)
    {
        if (is_array($str))
            return FALSE;
        if (function_exists('mb_strlen'))
            return mb_strlen($str, 'utf-8');
        return strlen($str);
    }


    /**
     * Generate MAC keyed hash value using the HMAC method to send to External website
     *
     * Message Authentication Code: it prevents the end user from changing the order data.
     *
     * @param string      $urlms
     * @param string      $urldone
     * @param string      $orderid
     * @param string      $shopip
     * @param             $amount
     * @param string      $currency
     * @param string      $exponent
     * @param string      $accountingmode
     * @param string      $authormode
     * @param string      $name
     * @param string      $surname
     * @param string      $ordDescr
     * @param string      $startSecretString
     * @param string      $lockcard
     * @param null|string $options
     * @param string      $dsDAta //3DSData encrypted value
     *
     * @return false|string
     */
    public function generateMAC_request ($urlms, $urldone, $orderid, $shopip, $amount, $currency, $exponent, $accountingmode, $authormode, $name, $surname, $ordDescr, $startSecretString, $lockcard, $options, $dsDAta)
    {
        $strToHash = "URLMS=$urlms&URLDONE=$urldone&ORDERID=$orderid&SHOPID=$shopip&AMOUNT=$amount&CURRENCY=$currency&EXPONENT=$exponent&ACCOUNTINGMODE=$accountingmode&AUTHORMODE=$authormode";
        if (!empty($options)) {
            $strToHash .= "&OPTIONS=$options";
        }
        if (!empty($lockcard)) {
            $strToHash .= "&LOCKCARD=$lockcard";
        }

        $strToHash .= "&3DSDATA=$dsDAta";

        $hashMac = hash_hmac('sha256', $strToHash, $startSecretString);

        // Write log with mac value(s)
        //$this->log("MAC STRING = " . $strToHash);
        //$this->log("MAC HASH = " . $hashMac);

        return $hashMac;
    }

    /**
     * Generate Outcome MAC with parameters sended from External web site, and return keyed hash value using the HMAC method
     *
     * @param $orderid
     * @param $shopid
     * @param $authnumber
     * @param $amount
     * @param $currency
     * @param $exponent
     * @param $transactionid
     * @param $accountingmode
     * @param $authormode
     * @param $result
     * @param $transactiontype
     * @param $issuercountry
     * @param $outcome_key
     *
     * @return false|string
     */
    public function generateMAC_outcome ($orderid, $shopid, $authnumber, $amount, $currency, $exponent, $transactionid, $accountingmode, $authormode, $result, $transactiontype, $issuercountry
        , $payerid
        , $payer
        , $payerstatus
        , $hashpan
        , $iban
        , $accountholder
        , $aliasstr
        , $pantail
        , $panexpirydate
        , $panalias
        , $panaliasrev
        , $panaliasexpdate
        , $panaliastail
        , $maskedpan
        , $acquirerbin
        , $merchantid
        , $cardtype
        , $outcome_key)
    {
        $strMac = "ORDERID=$orderid&SHOPID=$shopid&AUTHNUMBER=$authnumber&AMOUNT=$amount&CURRENCY=$currency";
        empty($exponent) ? : $strMac .= "&EXPONENT=$exponent";
        $strMac .= "&TRANSACTIONID=$transactionid&ACCOUNTINGMODE=$accountingmode&AUTHORMODE=$authormode&RESULT=$result&TRANSACTIONTYPE=$transactiontype";
        empty($issuercountry) ? : $strMac .= "&ISSUERCOUNTRY=$issuercountry";

        if ($payerid !== NULL)
            $strMac .= "&PAYERID=" . $payerid;

        if ($payer !== NULL)
            $strMac .= "&PAYER=" . $payer;

        if ($payerstatus !== NULL)
            $strMac .= "&PAYERSTATUS=" . $payerstatus;

        if ($hashpan !== NULL)
            $strMac .= "&HASHPAN=" . $hashpan;

        if ($iban !== NULL)
            $strMac .= "&IBAN=" . $iban;

        if ($accountholder !== NULL)
            $strMac .= "&ACCOUNTHOLDER=" . $accountholder;

        if ($aliasstr !== NULL)
            $strMac .= "&ALIASSTR=" . $aliasstr;

        if ($pantail !== NULL)
            $strMac .= "&PANTAIL=" . $pantail;

        if ($panexpirydate !== NULL)
            $strMac .= "&PANEXPIRYDATE=" . $panexpirydate;

        if ($panalias !== NULL)
            $strMac .= "&PANALIAS=" . $panalias;

        if ($panaliasrev !== NULL)
            $strMac .= "&PANALIASREV=" . $panaliasrev;

        if ($panaliasexpdate !== NULL)
            $strMac .= "&PANALIASEXPDATE=" . $panaliasexpdate;

        if ($panaliastail !== NULL)
            $strMac .= "&PANALIASTAIL=" . $panaliastail;

        if ($maskedpan !== NULL)
            $strMac .= "&MASKEDPAN=" . $maskedpan;

        if ($acquirerbin !== NULL)
            $strMac .= "&ACQUIRERBIN=" . $acquirerbin;

        if ($merchantid !== NULL)
            $strMac .= "&MERCHANTID=".$merchantid;

        if ($cardtype !== NULL)
            $strMac .= "&CARDTYPE=".$cardtype;

        return hash_hmac('sha256', $strMac, $outcome_key);
    }
}